#include "X3D_DFSNavigationWalker.h"
#include "X3D_Collision.h"

#include <iostream>
using namespace std;

namespace X3DTK {
namespace X3D {

DFSNavigationWalker::DFSNavigationWalker()
: X3DComponentWalker()
{
  defineComponentName("Navigation", "X3D");
  
  defineWalkingFunction(&DFSNavigationWalker::walkCollision);  
}

DFSNavigationWalker::~DFSNavigationWalker()
{
}

void DFSNavigationWalker::walkCollision(Collision *C) const
{
  visitor->enter(C);
  
  MFNode children = C->getChildren();
  for (MFNode::iterator it = children.begin(); it != children.end(); ++it)
    if ((*it != 0) && (visitor->walkOn(C, *it)))
      walker->walk(*it);
  
  SFNode N = C->getProxy();
  if ((N != 0) && (visitor->walkOn(C, N)))
    walker->walk(N);
    
  visitor->leave(C);
}

}
}
