#include "X3D_Switch.h"

#include <iostream>

using namespace std;

namespace X3DTK {
namespace X3D {

Switch::Switch()
: X3DGroupingNode(), X3DBoundedObject(), _whichChoice(-1)
{
  defineTypeName("Switch", "Grouping");
}

Switch::Switch(const SFInt32 &whichChoice, const SFVec3f &bboxCenter,  const SFVec3f &bboxSize)
: X3DGroupingNode(), X3DBoundedObject(bboxCenter, bboxSize), _whichChoice(whichChoice)
{
  defineTypeName("Switch", "Grouping");
}

Switch::Switch(const Switch &S)
: X3DGroupingNode(S), X3DBoundedObject(S), _whichChoice(S._whichChoice)
{
}

SFAbstractNode Switch::clone() const
{
  return new Switch(*this);
}

Switch::~Switch()
{
}

void Switch::setWhichChoice(const SFInt32 &whichChoice)
{
  _whichChoice = whichChoice;
}

void Switch::load(const X3DFileElement *element)
{
  X3DBoundedObject::load(element);
  
  int index;  
  index = element->getIndexAttribute("whichChoice");
  if (index != -1)
    _whichChoice = element->getAttribute(index).toInt(); 
}

SFString &Switch::write(SFString &output) const
{
  if (_whichChoice != -1)
    output += " whichChoice=\"" + toSFString(_whichChoice) + "\"";
 
  return output;   
}

}
}
